Bug 739144 - binutils TOC and PLT optimizations
Summary: binutils TOC and PLT optimizations
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: binutils
Version: 6.3
Hardware: ppc64
OS: All
high
high
Target Milestone: beta
: 6.3
Assignee: Nick Clifton
QA Contact: qe-baseos-tools
URL:
Whiteboard:
Depends On:
Blocks: 704634 705085
TreeView+ depends on / blocked
 
Reported: 2011-09-16 15:43 UTC by IBM Bug Proxy
Modified: 2012-06-20 14:03 UTC (History)
9 users (show)

Fixed In Version: binutils-2.20.51.0.2-5.34.el6
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-06-20 14:03:39 UTC


Attachments (Terms of Use)
rhel6 powerpc binutils patchset (30.73 KB, application/octet-stream)
2012-01-11 22:30 UTC, IBM Bug Proxy
no flags Details
Tarball containing patches packaged in a suitable way to apply to the RHEL 6.3 binutils srpm (24.61 KB, application/bzip2)
2012-02-22 12:55 UTC, Nick Clifton
no flags Details
replacement binutils-rh739144,patch (113.01 KB, patch)
2012-04-26 12:54 UTC, Alan Modra
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2012:0872 normal SHIPPED_LIVE binutils bug fix and enhancement update 2012-06-19 20:47:50 UTC
IBM Linux Technology Center 74747 None None None Never

Description IBM Bug Proxy 2011-09-16 15:43:34 UTC
1. Feature Overview:
Feature Id: [74747]
a. Name of Feature: binutils TOC and PLT optimizations
b. Feature Description

binutils TOC and PLT optimizations: Linker changes to improve performance of TOC addressability and PLT call stubs.

This is follow-on work to the Large-TOC changes made in the previous release.  These changes allow us to improve the performance of some TOC accesses when the compiler/linker can determine a better sequence of instructions can be used.  We also improve the sequence of instructions in the PLT call stubs to improve performance under certain circumstances.


2. Feature Details:
Sponsor: LTC Toolchain
Architectures:  ppc64, 

Arch Specificity: both
Affects Kernel Modules: No
Delivery Mechanism: Backport
Category: other
Request Type: Package - Feature from Upstream
d. Upstream Acceptance: In Progress
Sponsor Priority P2
f. Severity: high
IBM Confidential: No
Code Contribution: IBM code
g. Component Version Target: ---

3. Business Case
Recent reports of large programs (SAP, doxygen) failing during compile/link due to TOC overflow.  Also, some applications experience performance degrading with the current multi-TOC support.  This feature simplifies the build process while improving performance.

4. Primary contact at Red Hat:
John Jarvis, jjarvis@redhat.com

5. Primary contacts at Partner:
Project Management Contact:
Michael L. Hohnbaum, hbaum@us.ibm.com

Technical contact(s):
Peter E. Bergner, bergner@us.ibm.com

Comment 2 John Jarvis 2011-09-23 23:01:57 UTC
IBM is signed up to test and provide feedback, setting OtherQA.

Comment 3 Jeff Law 2011-12-16 06:15:10 UTC
Waiting on upstream patch incorporation & identification from IBM.

Comment 4 IBM Bug Proxy 2012-01-11 22:30:28 UTC
Created attachment 552249 [details]
rhel6 powerpc binutils patchset


------- Comment on attachment From amodra@au1.ibm.com 2012-01-11 17:27 EDT-------


Patches related to toc/plt optimization plus a few others.

Comment 5 Siddharth Nagar 2012-02-15 15:47:40 UTC
May I have an update on this please? We are now mid-way in the Development cycle and I'd like to know if we are still targeting to include this for RHEL 6.3.

Comment 6 IBM Bug Proxy 2012-02-15 16:10:49 UTC
------- Comment From hohnbaum@us.ibm.com 2012-02-15 11:03 EDT-------
Patches are attached to this bugzilla - were attached Jan 11.  Code is accepted upstream.

What additional information do you need?

Comment 7 Nick Clifton 2012-02-22 12:55:17 UTC
Created attachment 564945 [details]
Tarball containing patches packaged in a suitable way to apply to the RHEL 6.3 binutils srpm

The tarball contains the patches supplied by IBM integrated into a single, large patchfile, plus an update to binutils.spec to include the patch in a binutils build.

Comment 10 John Jarvis 2012-02-22 17:01:49 UTC
This enhancement request was evaluated by the full Red Hat Enterprise Linux
team for inclusion in a Red Hat Enterprise Linux minor release.   As a result
of this evaluation, Red Hat has tentatively approved inclusion of this feature
in the next Red Hat Enterprise Linux Update minor release.   While it is a goal
to include this enhancement in the next minor release of Red Hat Enterprise
Linux, the enhancement is not yet committed for inclusion in the next minor
release pending the next phase of actual code integration and successful Red
Hat and partner testing.

Comment 15 Alan Modra 2012-04-26 12:54:00 UTC
Created attachment 580466 [details]
replacement binutils-rh739144,patch

Nick, in looking over binutils-2.20.51.0.2-5.32.el6.src.rpm I noticed that a hunk is missing from binutils-rh739144.patch near the start of elf64-ppc.c:ppc64_elf_tls_optimize, probably due to a patch reject.  Attached please find a replacement.

Comment 16 John Jarvis 2012-04-26 13:35:02 UTC
Flipping back to ASSIGNED to get the patch reevaluated.

Comment 17 Michal Nowak 2012-04-27 12:27:33 UTC
(In reply to comment #15)
> Created attachment 580466 [details]
> replacement binutils-rh739144,patch
> 
> Nick, in looking over binutils-2.20.51.0.2-5.32.el6.src.rpm I noticed that a
> hunk is missing from binutils-rh739144.patch near the start of
> elf64-ppc.c:ppc64_elf_tls_optimize, probably due to a patch reject.  Attached
> please find a replacement.

Please note that this patch is missing testsuite updates.

Comment 23 Michal Nowak 2012-05-09 09:35:08 UTC
Alan, please inspect binutils-2.20.51.0.2-5.34.el6 SRPM once it gets near to you.

Comment 25 Michal Nowak 2012-05-14 13:11:04 UTC
I'd like IBM to have a look at binutils-2.20.51.0.2-5.34.el6 SRPM, please.

Comment 27 IBM Bug Proxy 2012-05-14 15:42:37 UTC
------- Comment From bergner@us.ibm.com 2012-05-14 15:35 EDT-------
I'll ping Alan offline to make sure he has a look at the updated binutils src rpm.

Comment 29 IBM Bug Proxy 2012-05-15 05:00:44 UTC
------- Comment From amodra@au1.ibm.com 2012-05-15 04:59 EDT-------
Michal, I saw your note last week and have been waiting for the source rpm to appear on ftp3.linux.ibm.com.  It's still not there.  Can I access the rpm somewhere else?

Comment 30 IBM Bug Proxy 2012-05-20 10:40:43 UTC
------- Comment From amodra@au1.ibm.com 2012-05-20 10:30 EDT-------
binutils-2.20.51.0.2-5.34.el6.src.rpm looks good to me.  Thanks!

Comment 31 Michal Nowak 2012-05-21 08:34:28 UTC
Added IBM to verified field.

Moving to VERIFIED per comment #30.

Comment 33 errata-xmlrpc 2012-06-20 14:03:39 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHBA-2012-0872.html


Note You need to log in before you can comment on or make changes to this bug.